## Add-on EventManager Extension Project
## Copyright Shin 2006
## (if any portion of this copyright should be found to be void, the remainder shall remain in full effect)
## 
## CvAddonEventManager
#
#
# swiped from the Python Moon demo Mod
# --Shin
# (aka. Belizan)


from CvPythonExtensions import *
from CvScreenEnums import *
import CvUtil
import CvScreensInterface
import CvDebugTools
import CvWBPopups
import PyHelpers
import Popup as PyPopup
import CvCameraControls
import CvTopCivs
import CvEventManager
import CvWorldBuilderScreen
import CvAdvisorUtils
import CvTechChooser
import PlayerUtils
import CityUtils

import CvHighlightEvents
import CvFFHSpellsEventManager

gc = CyGlobalContext()
localText = CyTranslator()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo
bCityPlacementMode = False
bBarbarianMarkers = False
bListBarbarians = False

###################################################
class CvAddonEventManager(CvFFHSpellsEventManager.CvFFHSpellsEventManager):
    def __init__(self):
        # replace this with the event manager class of the mod being added onto
        self.parent = CvFFHSpellsEventManager.CvFFHSpellsEventManager
        self.parent.__init__(self)
        self.hilite = CvHighlightEvents.PlotHighlight()
        self.CustomEvents={
            5022 : ('EventSignPopup', self.__eventMoonModAddSignEventPopupApply, self.__eventMoonModAddSignEventPopupBegin),
            5023 : ('EventSignPopup', self.__eventMoonModAddSiteEventPopupApply, self.__eventMoonModAddSiteEventPopupBegin),
        }
        
    def beginEvent( self, context, argsList=-1 ):
        'Begin Event'
        if(self.CustomEvents.has_key(context)):
            return self.CustomEvents[context][2](argsList)
        else:
            return self.parent.beginEvent(self, context, argsList)
            
    def applyEvent( self, argsList ):
        'Apply the effects of an event '
        context, playerID, netUserData, popupReturn = argsList

        if(self.CustomEvents.has_key(context)):
            entry = self.CustomEvents[context]
            return entry[1]( playerID, netUserData, popupReturn )   # the apply function
        else:
            return self.parent.applyEvent(self, argsList)

    def __eventMoonModAddSignEventPopupBegin(self, argsList):
        ' Add landmark sign popup '
        popup = PyPopup.PyPopup(5022, EventContextTypes.EVENTCONTEXT_ALL)
        popup.setUserData(argsList)
        popup.setHeaderString( "Add Marker..." )
        message = "What do you want your marker to say?"
        popup.setBodyString( message )
        popup.createEditBox( "" )
        popup.setEditBoxMaxCharCount( 15 )
        popup.launch(False, PopupStates.POPUPSTATE_QUEUED)
    
    def __eventMoonModAddSignEventPopupApply(self, playerID, netUserData, popupReturn):
        sCaption = str(popupReturn.getEditBoxString(0))
        pPlot = gc.getMap().plot(netUserData[0], netUserData[1])
        CyEngine().addSign(pPlot, playerID, sCaption)
        
    def __eventMoonModAddSiteEventPopupBegin(self, argsList):
        ' Add city marker popup '
        popup = PyPopup.PyPopup(5023, EventContextTypes.EVENTCONTEXT_ALL)
        popup.setUserData(argsList)
        popup.setHeaderString( "Place a City Site..." )
        message = "Enter city marker--"
        popup.setBodyString( message )
        popup.createEditBox( "City: " )
        popup.setEditBoxMaxCharCount( 21 )
        popup.launch(False, PopupStates.POPUPSTATE_QUEUED)
    
    def __eventMoonModAddSiteEventPopupApply(self, playerID, netUserData, popupReturn):
        sCaption = str(popupReturn.getEditBoxString(0))
        pPlot = gc.getMap().plot(netUserData[0], netUserData[1])
        CyEngine().addSign(pPlot, playerID, sCaption)
        PlayerUtils.addSiteToList(gc.getPlayer(playerID), pPlot)
    
        
        
    def onKbdEvent(self, argsList):
        eventType,key,mx,my,px,py = argsList
        global bListBarbarians
        global bBarbarianMarkers
        if ( eventType == self.EventKeyDown ):
            iKey = int(key)
            if(self.bCtrl and iKey == InputTypes.KB_K):
                pPlayer = gc.getActivePlayer()
                iGrid = PlayerUtils.getGameOption(pPlayer, "CityGrid")
                message = "Handling ctrl-k"
                #CyInterface().addMessage(0,True,len(message),message,'',0,'Art/Interface/Buttons/Units/Fighter.dds',ColorTypes(7),0,0,True,True)
                if(iGrid < 1):
                    iGrid = 1
                    PlayerUtils.setGameOption(pPlayer, "CityGrid", iGrid)
                    PlayerUtils.colorizeCityPlots(pPlayer)
                else:
                    iGrid = 0
                    PlayerUtils.setGameOption(pPlayer, "CityGrid", iGrid)
                    CyEngine().clearColoredPlots(PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_WORLD_BUILDER)
                return 1
            if(self.bCtrl and iKey == InputTypes.KB_L):
                pPlot = CyInterface().getMouseOverPlot()
                if(self.bShift):
                    bListBarbarians = not bListBarbarians
                    if(bListBarbarians):
                        message = "List Barbarians Mode enabled..."
                        CyInterface().addMessage(gc.getActivePlayer().getID(),True,len(message),message,'',0,'Art/Interface/Buttons/actions/Recon.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
                        if(bBarbarianMarkers):
                            PlayerUtils.colorizeUnitsByMP(gc.getPlayer(gc.getBARBARIAN_PLAYER()), gc.getActivePlayer(), False, bListBarbarians)
                    else:
                        message = "List Barbarian Mode disabled..."
                        CyInterface().addMessage(gc.getActivePlayer().getID(),True,len(message),message,'',0,'Art/Interface/Buttons/actions/Recon.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
                return 1
            if(self.bCtrl and iKey == InputTypes.KB_B):
                pPlot = CyInterface().getMouseOverPlot()
                if(self.bShift):
                    bBarbarianMarkers = not bBarbarianMarkers
                    if(bBarbarianMarkers):
                        message = "Marking Barbarians..."
                        CyInterface().addMessage(gc.getActivePlayer().getID(),True,len(message),message,'',0,'Art/Interface/Buttons/actions/Recon.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
                        PlayerUtils.colorizeUnitsByMP(gc.getPlayer(gc.getBARBARIAN_PLAYER()), gc.getActivePlayer(), True, bListBarbarians)
                    else:
                        message = "Removing Barbarian Markers..."
                        CyInterface().addMessage(gc.getActivePlayer().getID(),True,len(message),message,'',0,'Art/Interface/Buttons/actions/Recon.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
                        CyEngine().clearColoredPlots(PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_WORLD_BUILDER)
                    return 1
            if(self.bCtrl and iKey == InputTypes.KB_P):
                global bCityPlacementMode
                pPlot = CyInterface().getMouseOverPlot()
                if(self.bShift):
                    bCityPlacementMode = not bCityPlacementMode
                    #DebugUtils.debugStr("In City Placement Mode: %s" %(str(bCityPlacementMode)))
                    if(bCityPlacementMode):
                        message = "Switching to City Placement Mode..."
                        CyInterface().addMessage(gc.getActivePlayer().getID(),True,len(message),message,'',0,'Art/Interface/Buttons/actions/Recon.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
                    else:
                        message = "Leaving City Placement Mode..."
                        CyInterface().addMessage(gc.getActivePlayer().getID(),True,len(message),message,'',0,'Art/Interface/Buttons/actions/Recon.dds',ColorTypes(8),pPlot.getX(),pPlot.getY(),True,True)
                else:
                    if(bCityPlacementMode):
                        pPlayer = gc.getActivePlayer()
                        if(pPlot.isPeak() or pPlot.isWater() or pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_DUSTSEA") or pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_CRATERRIM") or not pPlot.isRevealed(pPlayer.getTeam(), False)):
                            pass
                        else:
                            bErase = False
                            for iSign in range(CyEngine().getNumSigns()):
                                pSign = CyEngine().getSignByIndex(iSign)
                                pSignPlot = pSign.getPlot()
                                if(pSignPlot.at(pPlot.getX(), pPlot.getY()) and pSign.getPlayerType() == pPlayer.getID()):
                                    bErase = True
                                    PlayerUtils.removeSiteFromList(pPlayer, pPlot)
                                    CyEngine().removeSign(pSignPlot, pPlayer.getID())
                                    break
                            if(bErase == False):
                                self.__eventMoonModAddSiteEventPopupBegin((pPlot.getX(), pPlot.getY(), pPlayer.getID()))
                    else:
                        pPlayer = gc.getActivePlayer()
                        iShowMoves = PlayerUtils.getGameOption(pPlayer, "ShowMoves")
                        if(iShowMoves < 1): 
                            iShowMoves = 1
                            PlayerUtils.setGameOption(pPlayer, "ShowMoves", iShowMoves)
                            #pUnit = CyInterface().getHeadSelectedUnit()
                            #if(not pUnit.isNone()):
                            #    pass    
                            if(CyInterface().getHeadSelectedUnit()):
                                if(not CyInterface().getHeadSelectedUnit().isNone()):
                                    self.hilite.onUpdate((1,1))
                        else:
                            iShowMoves = 0
                            PlayerUtils.setGameOption(pPlayer, "ShowMoves", iShowMoves)
                            self.hilite.hiliteOff()
                return 1
            if(self.bCtrl and iKey == InputTypes.KB_M):
                pPlayer = gc.getActivePlayer()
                pPlot = CyInterface().getMouseOverPlot()
                bErase = False
                for iSign in range(CyEngine().getNumSigns()):
                    pSign = CyEngine().getSignByIndex(iSign)
                    pSignPlot = pSign.getPlot()
                    if(pSignPlot.at(pPlot.getX(), pPlot.getY()) and pSign.getPlayerType() == pPlayer.getID()):
                        bErase = True
                        #PlayerUtils.removeSignFromList(pPlayer, pPlot)
                        CyEngine().removeSign(pSignPlot, pPlayer.getID())
                        break
                if(bErase == False):
                    self.__eventMoonModAddSignEventPopupBegin((pPlot.getX(), pPlot.getY(), pPlayer.getID()))
                    #ForensicsUtils.getInfoOnObject(CyEngine())
                #    CyEngine().addLandmarkPopup(pPlot)
                #    PlayerUtils.addSignToList(pPlayer, pPlot)
                return 1
                
        return self.parent.onKbdEvent(self, argsList)
    
    
    def onUpdate(self, argsList):
        pPlayer = gc.getActivePlayer()
        iShowMoves = PlayerUtils.getGameOption(pPlayer, "ShowMoves")
        if(iShowMoves == 1):
            self.hilite.onUpdate(argsList)
        
        iGrid = PlayerUtils.getGameOption(pPlayer, "CityGrid")
        if(iGrid == 1):
            PlayerUtils.colorizeCityPlots(pPlayer)
        
        global bBarbarianMarkers
        global bListBarbarians
        if(bBarbarianMarkers):
            PlayerUtils.colorizeUnitsByMP(gc.getPlayer(gc.getBARBARIAN_PLAYER()), pPlayer)
        
        global bCityPlacementMode
        if(bCityPlacementMode):
            PlayerUtils.colorizeCityPlots(pPlayer)
            PlayerUtils.colorizeCitySites(pPlayer)
            CityUtils.colorizeCityGridForPlot(CyInterface().getMouseOverPlot(), pPlayer)
    
    
    def onMouseEvent(self, argsList):
        pPlayer = gc.getActivePlayer()
        iShowMoves = PlayerUtils.getGameOption(pPlayer, "ShowMoves")
        if(iShowMoves == 1):
            self.hilite.onMouseEvent(argsList)
            
        global bCityPlacementMode
        if(bCityPlacementMode):
            CyEngine().clearColoredPlots(PlotLandscapeLayers.PLOT_LANDSCAPE_LAYER_WORLD_BUILDER)
            iGrid = PlayerUtils.getGameOption(pPlayer, "CityGrid")
            if(iGrid == 1):
                PlayerUtils.colorizeCityPlots(pPlayer)
            pPlot = CyInterface().getMouseOverPlot()
            if(pPlot.isPeak() or pPlot.isWater() or pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_DUSTSEA") or pPlot.getTerrainType() == gc.getInfoTypeForString("TERRAIN_CRATERRIM") or not pPlot.isRevealed(pPlayer.getTeam(), False)):
                pass
            else:
                bErase = False
                for iSign in range(CyEngine().getNumSigns()):
                    pSign = CyEngine().getSignByIndex(iSign)
                    pSignPlot = pSign.getPlot()
                    if(pSignPlot.at(pPlot.getX(), pPlot.getY()) and pSign.getPlayerType() == pPlayer.getID()):
                        bErase = True
                        PlayerUtils.removeSiteFromList(pPlayer, pPlot)
                        CyEngine().removeSign(pSignPlot, pPlayer.getID())
                        break
                if(bErase == False):
                    self.__eventMoonModAddSiteEventPopupBegin((pPlot.getX(), pPlot.getY(), pPlayer.getID()))
        