# Civilization 4 (c) 2005 Firaxis Games
#
# Move plot highlighting mod component
# by TGA (adapted by 12monkeys)
#
# Shin (Belizan) Note: Doesn't take into account decreased movement capacities of stacks.
#
# Email: The_great_Apple@hotmail.com

from CvPythonExtensions import *
import sys

import CvEventManager
from CvScreenEnums import *
from PyHelpers import *

import CvUtil

# globals
gc = CyGlobalContext()
localText = CyTranslator()
g_HighlightActive = 1

from AStarTools import *
ASMA = AStarMoveArea()


class PlotHighlight(CvEventManager.CvEventManager):	
    
    def __init__(self):
        self.parent = CvEventManager.CvEventManager
        self.parent.__init__(self)
        
    ################## Event Overrides ##################
    
    def hiliteOff(self):
        ' Turn off move hiliting '
        global g_HighlightActive
        ASMA.dehighlightMoveArea()
        g_HighlightActive = 1
        pUnit = CyInterface().getHeadSelectedUnit()
        ### Moon Mod Bugfix
        if(pUnit and not pUnit.isNone()):
            CyInterface().selectUnit(pUnit, False, False, False)
        ### /Moon Mod Bugfix
        
    
    def onUpdate(self, argsList):#called every frame
        global g_HighlightActive
        if(g_HighlightActive == 1):
            pUnit = CyInterface().getHeadSelectedUnit()
            if not (pUnit):
                ASMA.dehighlightMoveArea()
            else:
                ASMA.highlightMoveArea(pUnit)
            g_HighlightActive = 0
        #self.parent.onUpdate(self, argsList)
                
    def onMouseEvent(self, argsList):
        global g_HighlightActive
        g_HighlightActive = 1
        #self.parent.onMouseEvent(self, argsList)
    
    def onUnitSelected(self, argsList):
        global g_HighlightActive
        g_HighlightActive = 1
        #self.parent.onUnitSelected(self, argsList)
    
    def onUnitMove(self, argsList):
        global g_HighlightActive
        g_HighlightActive = 1
        #self.parent.onUnitMove(self, argsList)

